function [b, stats]= rq_bbb(X, y, p, boot_n_reps,block_size)
            
b = rq(X,y,p);

if ~exist('block_size','var')
    block_size = 1;
end

resid = y-X*b;


nobs=size(resid,1);
    %calc number of blocks
    nblocks=fix(nobs/block_size)+1;
    %%figure out what the remainder is
    remainder=mod(nobs, block_size);
    if remainder == 0
        remainder = block_size;
        nblocks = nobs/block_size;
    end
    
stats.pboot = nan*zeros(size(b,1),boot_n_reps);

for bootstrap_rep = 1:boot_n_reps
    %find random indices
    boot_strap_indices = block_size+1+round((nobs-block_size-1)*rand(1,nblocks));
    
    resid_bootstrap = zeros(nobs,1);
    %get indices from random numbers 
    for block_index=1:nblocks-1 
        resid_bootstrap((block_index-1)*block_size+1:block_index*block_size) = resid(boot_strap_indices(block_index)-block_size+1:boot_strap_indices(block_index));
    end
    block_index = nblocks;
    resid_bootstrap((block_index-1)*block_size+1:(block_index-1)*block_size+remainder) = resid(boot_strap_indices(block_index)-remainder+1:boot_strap_indices(block_index));
        
    yboot = X*b+resid_bootstrap;
    
    stats.pboot(:,bootstrap_rep) = rq(X,yboot,p);

end